/* ELRIC11.MOD */
/* Print out BBS stats about the system, V2.0 */
/* Written by Lord Elric .......*/
/* WWIVLink 2@18270 */
/* Thanks to The Black Dragon for some clues on file opening/closing/reading.
   You are free to use/modify/distribute this however you desire, as long as
   you leave the credits alone though, except to add your own. */

/* Multiline changes and output filename parameter added by Arc Angel of the
   Palace of the Gods (WWIVnet 1@4067). */
/* Chages to statistics reported, and format also by Arc Angel */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <dos.h>
#include <fcntl.h>
#include <time.h>
#include <sys\stat.h>
#include "vardec.h"

/* Multiline MOD */ #include <share.h>
/* Multiline MOD */ FILE *fopen_w(char *s, char *mode); /* open stream for write */
/* Multiline MOD */ int open_r(char *s); /* open file for read only */
long date_to_daten(char *datet);

void main(int argc, char *argv[])
{
  char sysname[51], userfile[81], outfilename[81], line[181], s[81];
  double age, logons, firston, laston, timeon, lastrate,
         uploaded, downloaded, uk, dk,
         emailsent, feedbacksent, msgpost, msgread, gfilesread, chainsrun;
  double maxage, maxlogons, maxfirston, maxlaston, maxtimeon, maxlastrate,
         maxuploaded, maxdownloaded, maxuk, maxdk, maxratio,
         maxemailsent, maxfeedbacksent, maxmsgpost, maxmsgread, maxgfilesread, maxchainsrun;
  double minage, minlogons, minfirston, minlaston, mintimeon, minlastrate,
         minuploaded, mindownloaded, minuk, mindk, minratio,
         minemailsent, minfeedbacksent, minmsgpost, minmsgread, mingfilesread, minchainsrun;
  int f, i, num, males, females, numusers, speed[5], ages[5], configfile, dirsfile, gamesfile, gfilesfile, subsfile;
  long l;
  FILE *outfile;
  configrec syscfg;
  userrec user;

  printf("\nWWIVstat program\n");
  if (argc<2) {
    printf("  Usage: WWIVstat <output-filename>\n");
    exit(1);
  }
  configfile=open_r("Config.dat");
  if (configfile<0) {
    printf("  Error: Config.dat not found.\n");
    printf("  This program must be run from the main BBS directory.\n");
    exit(1);
  }
  read(configfile,(void *) (&syscfg), sizeof(configrec));
  close(configfile);
  sprintf(userfile,"%sUSER.LST",syscfg.datadir);
  /* initialize some vars here */
  for (i=0;i<5;i++) {
     ages[i]=0;
     speed[i]=0;
  }
  males=females=0;
  age=logons=firston=laston=timeon=lastrate=0;
  uploaded=downloaded=uk=dk=0;
  emailsent=feedbacksent=msgpost=msgread=gfilesread=chainsrun=0;
  maxage=maxlogons=maxfirston=maxlaston=maxtimeon=maxlastrate=-1000000;
  maxuploaded=maxdownloaded=maxuk=maxdk=maxratio=-1000000;
  maxemailsent=maxfeedbacksent=maxmsgpost=maxmsgread=maxgfilesread=maxchainsrun=-1000000;
  minage=minlogons=minfirston=minlaston=mintimeon=minlastrate=100000;
  minuploaded=mindownloaded=minuk=mindk=minratio=100000;
  minemailsent=minfeedbacksent=minmsgpost=minmsgread=mingfilesread=minchainsrun=100000;
  if ((f=open_r(userfile))<=0) {
    printf("  Error: could not open user list %s.\n",userfile);
    exit(1);
  }

  strcpy(outfilename,argv[1]);
  if ((outfile=fopen_w(outfilename,"w"))<=0) {
    printf("  Error: could not open output file %s.\n",outfilename);
    exit(1);
  }
  l=filelength(f);
  num=(l/sizeof(userrec))+!(l%sizeof(userrec));
  numusers=0;
  time(&l);
  for (i=0;i<num;i++) {
    if (sizeof(userrec)==read(f,&user,sizeof(userrec))) {
      printf("\015  Processing user #%u of %u...",i,(num-2));
      if (i>1) { /* don't process sysop account */
        if (!(user.inact) && user.lastrate!=38400 && user.lastrate!=57600) {
          numusers++;

          age+=user.age;
          logons+=user.logons;
          firston+=(l-date_to_daten(user.firston))/24.0/3600.0;
          laston+=((l-user.daten)/24.0/3600.0);
          timeon+=user.timeon;
          lastrate+=user.lastrate;
          uploaded+=user.uploaded;
          downloaded+=user.downloaded;
          uk+=user.uk;
          dk+=user.dk;
          emailsent+=user.emailsent;
          feedbacksent+=user.feedbacksent;
          msgpost+=user.msgpost;
          msgread+=user.msgread;
          chainsrun+=user.chainsrun;
          gfilesread+=user.gfilesread;

          maxage=max(maxage,user.age);
          maxlogons=max(maxlogons,user.logons);
          maxfirston=max(maxfirston,(l-date_to_daten(user.firston))/24.0/3600.0);
          maxlaston=max(maxlaston,((l-user.daten)/24.0/3600.0));
          maxtimeon=max(maxtimeon,user.timeon);
          maxlastrate=max(maxlastrate,user.lastrate*(user.lastrate<9600 ? 1.0 : 0.80));
          maxuploaded=max(maxuploaded,user.uploaded);
          maxdownloaded=max(maxdownloaded,user.downloaded);
          maxuk=max(maxuk,user.uk);
          maxdk=max(maxdk,user.dk);
          maxratio=max(maxratio,(user.dk<1 ? 1.0 : (float)user.uk/user.dk));
          maxemailsent=max(maxemailsent,user.emailsent);
          maxfeedbacksent=max(maxfeedbacksent,user.feedbacksent);
          maxmsgpost=max(maxmsgpost,user.msgpost);
          maxmsgread=max(maxmsgread,user.msgread);
          maxchainsrun=max(maxchainsrun,user.chainsrun);
          maxgfilesread=max(maxgfilesread,user.gfilesread);

          minage=min(minage,user.age);
          minlogons=min(minlogons,user.logons);
          minfirston=min(minfirston,(l-date_to_daten(user.firston))/24.0/3600.0);
          minlaston=min(minlaston,((l-user.daten)/24.0/3600.0));
          mintimeon=min(mintimeon,user.timeon);
          minlastrate=min(minlastrate,user.lastrate*(user.lastrate<9600 ? 1.0 : 0.80));
          minuploaded=min(minuploaded,user.uploaded);
          mindownloaded=min(mindownloaded,user.downloaded);
          minuk=min(minuk,user.uk);
          mindk=min(mindk,user.dk);
          minratio=min(minratio,(user.dk<1 ? 1.0 : (float)user.uk/user.dk));
          minemailsent=min(minemailsent,user.emailsent);
          minfeedbacksent=min(minfeedbacksent,user.feedbacksent);
          minmsgpost=min(minmsgpost,user.msgpost);
          minmsgread=min(minmsgread,user.msgread);
          minchainsrun=min(minchainsrun,user.chainsrun);
          mingfilesread=min(mingfilesread,user.gfilesread);

          if (user.sex=='M') {
             males++;
          } else {
             females++;
          }
          if (user.age<14)
            ages[0]++;
          else
            if (user.age<19)
              ages[1]++;
            else
              if (user.age<22)
                ages[2]++;
              else
                ages[3]++;
        }
      }
    }
  }
  close(f);
    /*sprintf(line,"1Males    2%4i            1Females  2%4i\n\n",males,females);
    fputs(line,outfile);
    sprintf(line," 4 Age of Users \n");
    fputs(line,outfile);
    sprintf(line,"1Number of users under 14  2%4d     1Users 14 to 18  2%4d\n",
        age1,age2);
    fputs(line,outfile);
    sprintf(line,"          1Users 19 to 21  2%4d     1Users over  21  2%4d\n\n",
        age3,age4);
    fputs(line,outfile);*/

  fprintf(outfile,"3System user statistics for 64 %s 60\n\n",syscfg.systemname);
  fprintf(outfile,"  3Number of Users: 5%i0\n",numusers);
  fprintf(outfile,"  3User Statistics:0(2min0/5ave0/7max0)\n");
  fprintf(outfile,"    1Age: 2%.0f0/5%.0f0/7%.0f0\n",minage,age/numusers,maxage);
  fprintf(outfile,"    1Logons: 2%.0f0/5%.0f0/7%.0f0 in 2%.0f0/5%.0f0/7%.0f 0days\n",minlogons,logons/numusers,maxlogons,minfirston,firston/numusers,maxfirston);
  fprintf(outfile,"    1Last Online: 2%.0f0/5%.0f0/7%.0f 0days ago\n",minlaston,laston/numusers,maxlaston);
  fprintf(outfile,"    1Time Online: 2%.0f0/5%.0f0/7%.0f0 hours\n",mintimeon/3600.0,timeon/numusers/3600.0,maxtimeon/3600.0);
  fprintf(outfile,"    1Modem Speed: 2%.0f0/5%.0f0/7%.0f0\n\n",minlastrate,lastrate/numusers,maxlastrate);

  fprintf(outfile,"    1Email sent:  2%1.0f0/5%2.0f0/7%3.0f0   1Feedback sent: 2%.0f0/5%.0f0/7%.0f0\n",minemailsent,emailsent/numusers,maxemailsent,minfeedbacksent,feedbacksent/numusers,maxfeedbacksent);
  fprintf(outfile,"    1Msgs Posted: 2%1.0f0/5%2.0f0/7%3.0f0   1Msgs Read:     2%.0f0/5%.0f0/7%.0f0\n",minmsgpost,msgpost/numusers,maxmsgpost,minmsgread,msgread/numusers,maxmsgread);
  fprintf(outfile,"    1Chains Run:  2%1.0f0/5%2.0f0/7%3.0f0   1Gfiles Read:   2%.0f0/5%.0f0/7%.0f0\n\n",minchainsrun,chainsrun/numusers,maxchainsrun,mingfilesread,gfilesread/numusers,maxgfilesread);

  fprintf(outfile,"    1Uploads:   2%4.0f0/5%4.0f0/7%4.0f0 files 2%1.0f0/5%3.0f0/7%4.0f0 megabytes\n",minuploaded,uploaded/numusers,maxuploaded,minuk/1024.0,uk/numusers/1024.0,maxuk/1024.0);
  fprintf(outfile,"    1Downloads: 2%4.0f0/5%4.0f0/7%4.0f0 files 2%1.0f0/5%3.0f0/7%4.0f0 megabytes\n",mindownloaded,downloaded/numusers,maxdownloaded,mindk/1024.0,dk/numusers/1024.0,maxdk/1024.0);
  fprintf(outfile,"    1Ratio:     2%04.2f0/5%04.2f0/7%.2f0\n",minratio,(dk>1 ? uk/dk : 1.0),maxratio);
    /*sprintf(line," 4 Computers Represented \n");
    fputs(line,outfile);
    sprintf(line,"1IBM XT/8088  2%4d    1IBM AT/80286  2%4d    180386/486   2%4d\n",
    comp[0],comp[1],comp[2]);
    fputs(line,outfile);
    sprintf(line,"1IBM PS/2     2%4d    1Apple ]['s    2%4d    1Macintosh   2%4d\n",
    comp[3],comp[4],comp[5]);
    fputs(line,outfile);
    sprintf(line,"1Amiga        2%4d    1Commodore     2%4d\n",comp[6],comp[7]);
    fputs(line,outfile);
    sprintf(line,"1Atari        2%4d    1Other         2%4d\n\n",comp[8],comp[9]);
    fputs(line,outfile);
    sprintf(line,"        4 Total IBM users 0  2 %4d",comp[0]+comp[1]+comp[2]+comp[3]);
    fputs(line,outfile);*/
    fclose(outfile);
}

long date_to_daten(char *datet)
{
  struct time t;
  struct date d;

  if (strlen(datet)!=8)
    return(0);

  memset(&d, 0, sizeof(struct date));
  memset(&t, 0, sizeof(struct time));

  d.da_mon=atoi(datet);
  d.da_day=atoi(datet+3);
  d.da_year=1900+atoi(datet+6);

  return(dostounix(&d, &t));
}


/* Multiline MOD */ FILE *fopen_w(char *s, char *mode) /* open stream for write */
/* Multiline MOD */ {
/* Multiline MOD */   FILE *f;
/* Multiline MOD */
/* Multiline MOD */   f=_fsopen(s,mode,SH_DENYWR);
/* Multiline MOD */   return(f);
/* Multiline MOD */ }

/* Multiline MOD */ int open_r(char *s) /* open file for read only */
/* Multiline MOD */ {
/* Multiline MOD */   return(open(s,O_RDONLY | O_BINARY | O_DENYNONE));
/* Multiline MOD */ }

